"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.fromUtf8Base64 = exports.toUtf8Base64 = exports.LocalStorageCache = void 0;
var tslib_1 = require("tslib");
var configcat_common_1 = require("configcat-common");
var LocalStorageCache = /** @class */ (function () {
    function LocalStorageCache(storage) {
        this.storage = storage;
    }
    LocalStorageCache.setup = function (kernel, localStorageGetter) {
        var _a, _b, _c;
        var localStorage = (_a = localStorageGetter === null || localStorageGetter === void 0 ? void 0 : localStorageGetter()) !== null && _a !== void 0 ? _a : (_c = (_b = window.chrome) === null || _b === void 0 ? void 0 : _b.storage) === null || _c === void 0 ? void 0 : _c.local;
        if (localStorage) {
            kernel.defaultCacheFactory = function (options) { return new configcat_common_1.ExternalConfigCache(new LocalStorageCache(localStorage), options.logger); };
        }
        return kernel;
    };
    LocalStorageCache.prototype.set = function (key, value) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var _a;
            return tslib_1.__generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.storage.set((_a = {}, _a[key] = toUtf8Base64(value), _a))];
                    case 1:
                        _b.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    LocalStorageCache.prototype.get = function (key) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var cacheObj, configString;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.storage.get(key)];
                    case 1:
                        cacheObj = _a.sent();
                        configString = cacheObj[key];
                        if (configString) {
                            return [2 /*return*/, fromUtf8Base64(configString)];
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    return LocalStorageCache;
}());
exports.LocalStorageCache = LocalStorageCache;
function toUtf8Base64(str) {
    str = encodeURIComponent(str);
    str = str.replace(/%([0-9A-F]{2})/g, function (_, p1) { return String.fromCharCode(parseInt(p1, 16)); });
    return btoa(str);
}
exports.toUtf8Base64 = toUtf8Base64;
function fromUtf8Base64(str) {
    str = atob(str);
    str = str.replace(/[%\x80-\xFF]/g, function (m) { return "%" + m.charCodeAt(0).toString(16); });
    return decodeURIComponent(str);
}
exports.fromUtf8Base64 = fromUtf8Base64;
